/*
** Copyright (C) 1999, 2000 ABiSoft, Inc.
** All Rights Reserved.
** 
** This is UNPUBLISHED PROPRIETARY SOURCE CODE of ABiSoft, Inc.;
** the contents of this file may not be disclosed to third parties, copied or
** duplicated in any form, in whole or in part, without the prior written
** permission of ABiSoft, Inc.
** 
** RESTRICTED RIGHTS LEGEND:
** Use, duplication or disclosure by the Government is subject to restrictions
** as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
** and Computer Software clause at DFARS 252.227-7013, and/or in similar or
** successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
** rights reserved under the Copyright Laws of the United States.
*/

#ifndef IRC_EVENTS_H
#define IRC_EVENTS_H

const int IRC_UPDATE = 'Birc';
const int SEND_TO_SERVER = 'Bsts'; // don't worry about this... its for the IrcAddOn internal code

enum {
	// general
	JOIN,
	PART,
	QUIT,
	KICK,
 	MODE,
	OTHER,
	MESSAGE,
	NAMES,
	ACTION,
	TOPIC_ON_JOIN,
	TOPIC_CHANGED,
	TOPIC_SET_BY,
	NICK,
	OWN_NICK,
	STATUS_UPDATE,
	WHOIS_USER_INFO,
	WHOIS_SERVER_INFO,
	WHOIS_TIME_INFO,
	WHOIS_CHANNEL_INFO,
	WHOIS_END,
	ERROR,
	END_OF_NAMES,
	NOTICE,
	CTCP_REPLY,
	INVITE,
	INVITE_SUCCESSFUL,
	NOT_AWAY,
	AWAY,
	USER_AWAY,
	LIST_START,
	CHANNELS_LIST,
	ISON,
	LINKS,
	END_OF_LINKS,
	STATS,
	END_OF_STATS,
	// ctcp requests
	FINGER,
	DCC_SEND,
	DCC_CHAT,
	VERSION,
	USERINFO,
	CTCP_PING,
	UPTIME,
	SOUND,
	TIME,
	CTCP_UNKNOWN,
	// misc... I mean obscure
	MOTD_DONE,
	BAN_LIST,
	BAN_LIST_END,
	BANNED_FROM_CHANNEL, // a special error
	CHANNEL_MODES,
	MODES_SET_BY,
	NICK_IN_USE,
	PING,
	// UNKNOWN just means I dunno how to parse it...
	UNKNOWN,
	TIME_UPDATE, // This isn't really an IRC event. Don't look for these arriving
				// in your irc message loop anytime soon.
	// generated by Baxter
	SERVER_CONNECTING,
	SERVER_CONNECTED,
	SERVER_DISCONNECTED,
	SERVER_CONNECT_FAILED,
	RECONNECTING,
	MANUAL_RECONNECT_POSSIBLE,
	NOTIFICATION_USER_ONLINE,
	NOTIFICATION_USER_OFFLINE,
	// this one is only generated when you log on and Baxter does an ISON
	// the first time
	NOTIFICATION_USERS_ALREADY_ONLINE
};

enum {
	GET_USER_NICK,
	UPDATE_STATS
};

enum {
	DISPLAYED,
	NOT_DISPLAYED
};

// below are messages that the add-on can send to Baxter

enum {
	CREATE_DCC_VIEW = 1,
	EVENT_HANDLE_PRIVATE,
	EVENT_HANDLE_CHANNEL,
	EVENT_HANDLE_SERVER,
	EVENT_HANDLE_CHANNEL_CONTAINS,
	ACTIVE_VIEW,
	EXECUTE_CONNECTION_COMMANDS,
	SET_NICK,
	GET_NICK,
	GET_DOWNLOAD_DIRECTORY,
	CLOSE_SERVER_WINDOW,
	PLAY_SOUND,
	DO_ALLME,
	TO_ALL_OPS,
	DO_ALLMESSAGE,
	CONNECT_TO_SERVER,
	CHANNEL_LIST,
	CHANNEL_LIST_UPDATE,
	NOTIFY_LIST,
	NOTIFY_LIST_UPDATE,
	RECONNECT,
	SPRAY_CTCP_SOUND
};

enum {
	SOUND_CONNECTED,
	SOUND_DCC_CHAT_REQUEST,
	SOUND_PRIVATE_MESSAGE,
	SOUND_CHAT_IN_FOCUS_CHANNEL,
	SOUND_CHAT_IN_CHANNEL,
	SOUND_CHAT_CONTAINS_NICK,
	SOUND_JOIN,
	SOUND_PART,
	SOUND_QUIT,
	SOUND_KICK,
	SOUND_BAN,
	SOUND_YOU_KICKED,
	SOUND_NOTIFY,
	SOUND_NOTIFY_PART,
	
	SOUND_USER_OPPED,
	SOUND_YOU_OPPED,
	SOUND_USER_DEOPPED,
	SOUND_YOU_DEOPPED,
	SOUND_MOTD_DONE,
	SOUND_MODE_CHANGE
};

#define NickString "baxter:nick";

#define COLOR 3
#define BOLD 2
#define UNDERLINE 31
#define REVERSE 22
#define PLAIN 15
#define BEEP 7

#endif
