/*
** Copyright 1999, 2000 ABiSoft, Inc.
** All Rights Reserved.
** 
** This is UNPUBLISHED PROPRIETARY SOURCE CODE of ABiSoft, Inc.;
** the contents of this file may not be disclosed to third parties, copied or
** duplicated in any form, in whole or in part, without the prior written
** permission of ABiSoft, Inc.
** 
** RESTRICTED RIGHTS LEGEND:
** Use, duplication or disclosure by the Government is subject to restrictions
** as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
** and Computer Software clause at DFARS 252.227-7013, and/or in similar or
** successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
** rights reserved under the Copyright Laws of the United States.
*/

#include "IrcEvents.h"
#include "IrcAddOn.h"
#include <stdio.h>
#include <stdlib.h>
#include <List.h>
#include <string.h>
#include <Alert.h>
#include <SupportDefs.h>
#include <netdb.h>
#ifdef __X86__
#include <algo.h>
#include <cpp/string>
#include <stl_algo.h>
#include <stl_rope.h>
#else
#include <algorithm>
#include <string>
#endif
#include <FilePanel.h>
#include <Looper.h>
#include <Path.h>
#include <Entry.h>
#include <File.h>
#include <ListView.h>
#include <Box.h>
#include <ScrollView.h>
#include <ScrollBar.h>
#include <ListItem.h>
#include <MenuItem.h>

class TTT;

struct ttt_recv 
{
	ulong ip;
	ulong port;
	string nick;
	TTT *add_on;
};

struct ttt_send 
{
	string nick;
	TTT *add_on;
};

class TTT : 
	public IrcAddOn
{
public:
	TTT(BLooper *server_connection);
	
	virtual ~TTT();
	virtual char *Name();
	virtual char *Description();
	virtual bool HandleUserEntry(const char *entry, const char *channel, IrcView *view, bool *deleted_view, BMessage *msg);
	virtual uint32 HandleEvent(uint32 type, char *raw, uint32 previously, BMessage *msg);
	virtual void MessageReceived(BMessage *msg);
	virtual bool LooperNeedsQuit();
	virtual BMenuItem *MenuItem();
	virtual void HandleMenuItem(BMenuItem *mi, BList *users);
private:
	// string processing
	void stop_at(char *buf, char stop);

	void Receive(ttt_recv recv);
	static status_t _recv(void *arg);
	void Send(ttt_send recv);
	static status_t _send(void *arg);
	
	BList fWindowList;
	bool fQuit;
};

enum {
	SAVE_FILE,
	SEND_FILE,
	ACCEPT_TTT
};