#ifndef TTT_VIEW_H
#define TTT_VIEW_H

#include <View.h>
#include <Bitmap.h>
#include <stdio.h>

const uint32 SQUARE_CLICKED = 'squr';

const int32 blank = 0;
const int32 X = 1;
const int32 O = 4;

class TTTView : public BView
{
public:
	TTTView(BRect frame);
	~TTTView();
	
	virtual void MouseDown(BPoint pt);
	virtual void Draw(BRect);
	void MarkSquare(int32 which, int32 m);
	void CheckForWin(int32 x, int32 y);
	void Disconnected();
private:
	void DrawLines();
	
	BBitmap *fDraw, *fX, *fO;
	BView *fDrawView;
	BRect fSquare;
	bool fClickRestarts;
	
	int32 fMarks[3][3];
};

#endif